//Za domaci meni koji nudi 1. ubacivanje , 2. izbacivanje, 3. prikazivanje liste. Sa podmeniima
//napisati fju koja proverava da li je lista prazna

#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct cvor *PCvor;

typedef struct cvor {
	int podatak;
	//struct cvor *sledeci;
	PCvor sledeci;
} Cvor;

void ubaciNaPocetak(PCvor *glava, int x);
void prikaziListu(PCvor glava);
double vratiSrednjuVrednostParnih(PCvor glava);
void ubaciNaKraj(PCvor *glava, int x);
//fja vraca broj koji je izbacen iz liste
int izbaciSaPocetka(PCvor *glava);



int main() {

	PCvor glava;
	glava = NULL;
	ubaciNaKraj(&glava, 1);
	ubaciNaPocetak(&glava, 8);
	ubaciNaPocetak(&glava, 4);
	ubaciNaPocetak(&glava, 2);
	ubaciNaPocetak(&glava, 1);
	ubaciNaPocetak(&glava, 5);

	double srv = vratiSrednjuVrednostParnih(glava);
	printf("\nSrv parnih je %.2lf", srv);

	printf("\nElementi liste su: ");
	prikaziListu(glava);

	ubaciNaKraj(&glava, 3);
	printf("\nElementi liste su: ");
	prikaziListu(glava);

	int izbacen = izbaciSaPocetka(&glava);
	printf("\nElement koji je izbacen je: %d ", izbacen);
	izbacen = izbaciSaPocetka(&glava);
	printf("\nElement koji je izbacen je: %d ", izbacen);
	izbacen = izbaciSaPocetka(&glava);
	printf("\nElement koji je izbacen je: %d ", izbacen);

	printf("\nElementi liste su: ");
	prikaziListu(glava);

	printf("\n\n");
	system("pause");
	return 0;
}

void ubaciNaPocetak(PCvor *glava, int x) {
	PCvor novi;
	novi = malloc(sizeof(Cvor));
	//(*novi).podatak = x;
	novi->podatak = x;
	novi->sledeci = NULL;
	if (*glava == NULL) {
		*glava = novi;
	}
	else{
		novi->sledeci = *glava;
		*glava = novi;
	}
}

void prikaziListu(PCvor glava) {
	PCvor tek = glava;
	while (tek != NULL){
		printf("%d\t", tek->podatak);
		tek = tek->sledeci;
	}
}

double vratiSrednjuVrednostParnih(PCvor glava) {
	PCvor tek = glava;
	int sum = 0, brojac = 0;
	while (tek != NULL){
		if (tek->podatak % 2 == 0) {
			sum += tek->podatak;
			brojac++;
		}
		tek = tek->sledeci;
		
	}
	//Napisati sledeca tri reda u jednom redu sa odgovarajucom naredbom
	if(brojac != 0)
		return (double)sum / brojac;
	else return 0;
}

void ubaciNaKraj(PCvor *glava, int x) {
	PCvor novi = malloc(sizeof(Cvor));
	novi->podatak = x;
	novi->sledeci = NULL;
	if (*glava == NULL) {
		ubaciNaPocetak(glava, x);
	}
	else {
		PCvor tek = *glava;
		while (tek->sledeci != NULL) {
			tek = tek->sledeci;
		}
		tek->sledeci = novi;
	}
}

int izbaciSaPocetka(PCvor *glava) {

	if (*glava == NULL) {
		return -1;//pretpostavimo da su elementi liste svi pozitivni
	}
	int izbacen = (*glava)->podatak;
	PCvor tek = *glava;
	*glava = tek->sledeci;
	free(tek);
	return izbacen;
}
